--- old/usr/src/uts/common/os/zone.c	Wed Oct  5 00:33:52 2016
+++ new/usr/src/uts/common/os/zone.c	Wed Oct  5 00:33:52 2016
@@ -375,8 +375,6 @@
 rctl_hndl_t rc_zone_phys_mem;
 rctl_hndl_t rc_zone_max_lofi;
 rctl_hndl_t rc_zone_cpu_cap;
-rctl_hndl_t rc_zone_cpu_baseline;
-rctl_hndl_t rc_zone_cpu_burst_time;
 rctl_hndl_t rc_zone_zfs_io_pri;
 rctl_hndl_t rc_zone_nlwps;
 rctl_hndl_t rc_zone_nprocs;
@@ -423,9 +421,8 @@
  * Version 5 alters the zone_boot system call, and converts its old
  *     bootargs parameter to be set by the zone_setattr API instead.
  * Version 6 adds the flag argument to zone_create.
- * Version 7 adds the requested zoneid to zone_create.
  */
-static const int ZONE_SYSCALL_API_VERSION = 7;
+static const int ZONE_SYSCALL_API_VERSION = 6;
 
 /*
  * Certain filesystems (such as NFS and autofs) need to know which zone
@@ -1382,77 +1379,7 @@
 	rcop_no_test
 };
 
-/*ARGSUSED*/
-static rctl_qty_t
-zone_cpu_base_get(rctl_t *rctl, struct proc *p)
-{
-	ASSERT(MUTEX_HELD(&p->p_lock));
-	return (cpucaps_zone_get_base(p->p_zone));
-}
-
 /*
- * The zone cpu base is used to set the baseline CPU for the zone
- * so we can track when the zone is bursting.
- */
-/*ARGSUSED*/
-static int
-zone_cpu_base_set(rctl_t *rctl, struct proc *p, rctl_entity_p_t *e,
-    rctl_qty_t nv)
-{
-	zone_t *zone = e->rcep_p.zone;
-
-	ASSERT(MUTEX_HELD(&p->p_lock));
-	ASSERT(e->rcep_t == RCENTITY_ZONE);
-
-	if (zone == NULL)
-		return (0);
-
-	return (cpucaps_zone_set_base(zone, nv));
-}
-
-static rctl_ops_t zone_cpu_base_ops = {
-	rcop_no_action,
-	zone_cpu_base_get,
-	zone_cpu_base_set,
-	rcop_no_test
-};
-
-/*ARGSUSED*/
-static rctl_qty_t
-zone_cpu_burst_time_get(rctl_t *rctl, struct proc *p)
-{
-	ASSERT(MUTEX_HELD(&p->p_lock));
-	return (cpucaps_zone_get_burst_time(p->p_zone));
-}
-
-/*
- * The zone cpu burst time is used to set the amount of time CPU(s) can be
- * bursting for the zone.
- */
-/*ARGSUSED*/
-static int
-zone_cpu_burst_time_set(rctl_t *rctl, struct proc *p, rctl_entity_p_t *e,
-    rctl_qty_t nv)
-{
-	zone_t *zone = e->rcep_p.zone;
-
-	ASSERT(MUTEX_HELD(&p->p_lock));
-	ASSERT(e->rcep_t == RCENTITY_ZONE);
-
-	if (zone == NULL)
-		return (0);
-
-	return (cpucaps_zone_set_burst_time(zone, nv));
-}
-
-static rctl_ops_t zone_cpu_burst_time_ops = {
-	rcop_no_action,
-	zone_cpu_burst_time_get,
-	zone_cpu_burst_time_set,
-	rcop_no_test
-};
-
-/*
  * zone.zfs-io-pri resource control support (IO priority).
  */
 /*ARGSUSED*/
@@ -1986,7 +1913,7 @@
 }
 
 static kstat_t *
-zone_rctl_kstat_create_common(zone_t *zone, char *name,
+zone_kstat_create_common(zone_t *zone, char *name,
     int (*updatefunc) (kstat_t *, int))
 {
 	kstat_t *ksp;
@@ -2215,6 +2142,7 @@
 	/* The kstat "name" field is not large enough for a full zonename */
 	kstat_named_init(&zmp->zm_zonename, "zonename", KSTAT_DATA_STRING);
 	kstat_named_setstr(&zmp->zm_zonename, zone->zone_name);
+	kstat_named_setstr(&zmp->zm_zonename, zone->zone_name);
 	kstat_named_init(&zmp->zm_rss, "rss", KSTAT_DATA_UINT64);
 	kstat_named_init(&zmp->zm_phys_cap, "physcap", KSTAT_DATA_UINT64);
 	kstat_named_init(&zmp->zm_swap, "swap", KSTAT_DATA_UINT64);
@@ -2268,8 +2196,6 @@
 	zmp->zm_ffnomem.value.ui32 = zone->zone_ffnomem;
 	zmp->zm_ffmisc.value.ui32 = zone->zone_ffmisc;
 
-	zmp->zm_mfseglim.value.ui32 = zone->zone_mfseglim;
-
 	zmp->zm_nested_intp.value.ui32 = zone->zone_nested_intp;
 
 	zmp->zm_init_pid.value.ui32 = zone->zone_proc_initpid;
@@ -2313,8 +2239,6 @@
 	    KSTAT_DATA_UINT32);
 	kstat_named_init(&zmp->zm_ffnomem, "forkfail_nomem", KSTAT_DATA_UINT32);
 	kstat_named_init(&zmp->zm_ffmisc, "forkfail_misc", KSTAT_DATA_UINT32);
-	kstat_named_init(&zmp->zm_mfseglim, "mapfail_seglim",
-	    KSTAT_DATA_UINT32);
 	kstat_named_init(&zmp->zm_nested_intp, "nested_interp",
 	    KSTAT_DATA_UINT32);
 	kstat_named_init(&zmp->zm_init_pid, "init_pid", KSTAT_DATA_UINT32);
@@ -2330,13 +2254,13 @@
 static void
 zone_kstat_create(zone_t *zone)
 {
-	zone->zone_lockedmem_kstat = zone_rctl_kstat_create_common(zone,
+	zone->zone_lockedmem_kstat = zone_kstat_create_common(zone,
 	    "lockedmem", zone_lockedmem_kstat_update);
-	zone->zone_swapresv_kstat = zone_rctl_kstat_create_common(zone,
+	zone->zone_swapresv_kstat = zone_kstat_create_common(zone,
 	    "swapresv", zone_swapresv_kstat_update);
-	zone->zone_physmem_kstat = zone_rctl_kstat_create_common(zone,
+	zone->zone_physmem_kstat = zone_kstat_create_common(zone,
 	    "physicalmem", zone_physmem_kstat_update);
-	zone->zone_nprocs_kstat = zone_rctl_kstat_create_common(zone,
+	zone->zone_nprocs_kstat = zone_kstat_create_common(zone,
 	    "nprocs", zone_nprocs_kstat_update);
 
 	if ((zone->zone_vfs_ksp = zone_vfs_kstat_create(zone)) == NULL) {
@@ -2344,11 +2268,6 @@
 		    sizeof (zone_vfs_kstat_t), KM_SLEEP);
 	}
 
-	if ((zone->zone_zfs_ksp = zone_zfs_kstat_create(zone)) == NULL) {
-		zone->zone_zfs_stats = kmem_zalloc(
-		    sizeof (zone_zfs_kstat_t), KM_SLEEP);
-	}
-
 	if ((zone->zone_mcap_ksp = zone_mcap_kstat_create(zone)) == NULL) {
 		zone->zone_mcap_stats = kmem_zalloc(
 		    sizeof (zone_mcap_kstat_t), KM_SLEEP);
@@ -2358,6 +2277,7 @@
 		zone->zone_misc_stats = kmem_zalloc(
 		    sizeof (zone_misc_kstat_t), KM_SLEEP);
 	}
+
 }
 
 static void
@@ -2387,12 +2307,11 @@
 
 	zone_kstat_delete_common(&zone->zone_vfs_ksp,
 	    sizeof (zone_vfs_kstat_t));
-	zone_kstat_delete_common(&zone->zone_zfs_ksp,
-	    sizeof (zone_zfs_kstat_t));
 	zone_kstat_delete_common(&zone->zone_mcap_ksp,
 	    sizeof (zone_mcap_kstat_t));
 	zone_kstat_delete_common(&zone->zone_misc_ksp,
 	    sizeof (zone_misc_kstat_t));
+
 }
 
 /*
@@ -2454,6 +2373,7 @@
 	zone0.zone_physmem_kstat = NULL;
 	zone0.zone_nprocs_kstat = NULL;
 	zone0.zone_zfs_io_pri = 1;
+
 	zone0.zone_stime = 0;
 	zone0.zone_utime = 0;
 	zone0.zone_wtime = 0;
@@ -2564,16 +2484,6 @@
 	    RCTL_GLOBAL_INFINITE,
 	    MAXCAP, MAXCAP, &zone_cpu_cap_ops);
 
-	rc_zone_cpu_baseline = rctl_register("zone.cpu-baseline",
-	    RCENTITY_ZONE, RCTL_GLOBAL_SIGNAL_NEVER | RCTL_GLOBAL_DENY_NEVER |
-	    RCTL_GLOBAL_NOBASIC | RCTL_GLOBAL_COUNT | RCTL_GLOBAL_SYSLOG_NEVER,
-	    MAXCAP, MAXCAP, &zone_cpu_base_ops);
-
-	rc_zone_cpu_burst_time = rctl_register("zone.cpu-burst-time",
-	    RCENTITY_ZONE, RCTL_GLOBAL_SIGNAL_NEVER | RCTL_GLOBAL_DENY_NEVER |
-	    RCTL_GLOBAL_NOBASIC | RCTL_GLOBAL_COUNT | RCTL_GLOBAL_SYSLOG_NEVER,
-	    INT_MAX, INT_MAX, &zone_cpu_burst_time_ops);
-
 	rc_zone_zfs_io_pri = rctl_register("zone.zfs-io-priority",
 	    RCENTITY_ZONE, RCTL_GLOBAL_SIGNAL_NEVER | RCTL_GLOBAL_DENY_NEVER |
 	    RCTL_GLOBAL_NOBASIC | RCTL_GLOBAL_COUNT | RCTL_GLOBAL_SYSLOG_NEVER,
@@ -2620,20 +2530,6 @@
 	rde = rctl_dict_lookup("zone.cpu-shares");
 	(void) rctl_val_list_insert(&rde->rcd_default_value, dval);
 
-	/*
-	 * Create a rctl_val with PRIVILEGED, NOACTION, value = 1.  Then attach
-	 * this at the head of the rctl_dict_entry for ``zone.zfs-io-priority'.
-	 */
-	dval = kmem_cache_alloc(rctl_val_cache, KM_SLEEP);
-	bzero(dval, sizeof (rctl_val_t));
-	dval->rcv_value = 1;
-	dval->rcv_privilege = RCPRIV_PRIVILEGED;
-	dval->rcv_flagaction = RCTL_LOCAL_NOACTION;
-	dval->rcv_action_recip_pid = -1;
-
-	rde = rctl_dict_lookup("zone.zfs-io-priority");
-	(void) rctl_val_list_insert(&rde->rcd_default_value, dval);
-
 	rc_zone_locked_mem = rctl_register("zone.max-locked-memory",
 	    RCENTITY_ZONE, RCTL_GLOBAL_NOBASIC | RCTL_GLOBAL_BYTES |
 	    RCTL_GLOBAL_DENY_ALWAYS, UINT64_MAX, UINT64_MAX,
@@ -2838,8 +2734,6 @@
 static void
 zone_status_set(zone_t *zone, zone_status_t status)
 {
-	timestruc_t now;
-	uint64_t t;
 
 	nvlist_t *nvl = NULL;
 	ASSERT(MUTEX_HELD(&zone_status_lock));
@@ -2846,10 +2740,6 @@
 	ASSERT(status > ZONE_MIN_STATE && status <= ZONE_MAX_STATE &&
 	    status >= zone_status_get(zone));
 
-	/* Current time since Jan 1 1970 but consumers expect NS */
-	gethrestime(&now);
-	t = (now.tv_sec * NANOSEC) + now.tv_nsec;
-
 	if (nvlist_alloc(&nvl, NV_UNIQUE_NAME, KM_SLEEP) ||
 	    nvlist_add_string(nvl, ZONE_CB_NAME, zone->zone_name) ||
 	    nvlist_add_string(nvl, ZONE_CB_NEWSTATE,
@@ -2857,7 +2747,7 @@
 	    nvlist_add_string(nvl, ZONE_CB_OLDSTATE,
 	    zone_status_table[zone->zone_status]) ||
 	    nvlist_add_int32(nvl, ZONE_CB_ZONEID, zone->zone_id) ||
-	    nvlist_add_uint64(nvl, ZONE_CB_TIMESTAMP, t) ||
+	    nvlist_add_uint64(nvl, ZONE_CB_TIMESTAMP, (uint64_t)gethrtime()) ||
 	    sysevent_evc_publish(zone_event_chan, ZONE_EVENT_STATUS_CLASS,
 	    ZONE_EVENT_STATUS_SUBCLASS, "sun.com", "kernel", nvl, EVCH_SLEEP)) {
 #ifdef DEBUG
@@ -3458,12 +3348,6 @@
 	return (curproc->p_zone->zone_id);
 }
 
-zoneid_t
-getzonedid(void)
-{
-	return (curproc->p_zone->zone_did);
-}
-
 /*
  * Internal versions of zone_find_by_*().  These don't zone_hold() or
  * check the validity of a zone's state.
@@ -4808,8 +4692,7 @@
 }
 
 int
-zone_create_error(int er_error, int er_ext, int *er_out)
-{
+zone_create_error(int er_error, int er_ext, int *er_out) {
 	if (er_out != NULL) {
 		if (copyout(&er_ext, er_out, sizeof (int))) {
 			return (set_errno(EFAULT));
@@ -4899,13 +4782,13 @@
     caddr_t rctlbuf, size_t rctlbufsz,
     caddr_t zfsbuf, size_t zfsbufsz, int *extended_error,
     int match, uint32_t doi, const bslabel_t *label,
-    int flags, zoneid_t zone_did)
+    int flags)
 {
 	struct zsched_arg zarg;
 	nvlist_t *rctls = NULL;
 	proc_t *pp = curproc;
 	zone_t *zone, *ztmp;
-	zoneid_t zoneid, start = GLOBAL_ZONEID;
+	zoneid_t zoneid;
 	int error;
 	int error2 = 0;
 	char *str;
@@ -4920,59 +4803,8 @@
 		return (zone_create_error(ENOTSUP, ZE_CHROOTED,
 		    extended_error));
 
-	/*
-	 * As the first step of zone creation, we want to allocate a zoneid.
-	 * This allocation is complicated by the fact that netstacks use the
-	 * zoneid to determine their stackid, but netstacks themselves are
-	 * freed asynchronously with respect to zone destruction.  This means
-	 * that a netstack reference leak (or in principle, an extraordinarily
-	 * long netstack reference hold) could result in a zoneid being
-	 * allocated that in fact corresponds to a stackid from an active
-	 * (referenced) netstack -- unleashing all sorts of havoc when that
-	 * netstack is actually (re)used.  (In the abstract, we might wish a
-	 * zoneid to not be deallocated until its last referencing netstack
-	 * has been released, but netstacks lack a backpointer into their
-	 * referencing zone -- and changing them to have such a pointer would
-	 * be substantial, to put it euphemistically.)  To avoid this, we
-	 * detect this condition on allocation: if we have allocated a zoneid
-	 * that corresponds to a netstack that's still in use, we warn about
-	 * it (as it is much more likely to be a reference leak than an actual
-	 * netstack reference), free it, and allocate another.  That these
-	 * identifers are allocated out of an ID space assures that we won't
-	 * see the identifier we just allocated.
-	 */
-	for (;;) {
-		zoneid = id_alloc(zoneid_space);
-
-		if (!netstack_inuse_by_stackid(zoneid_to_netstackid(zoneid)))
-			break;
-
-		id_free(zoneid_space, zoneid);
-
-		if (start == GLOBAL_ZONEID) {
-			start = zoneid;
-		} else if (zoneid == start) {
-			/*
-			 * We have managed to iterate over the entire available
-			 * zoneid space -- there are no identifiers available,
-			 * presumably due to some number of leaked netstack
-			 * references.  While it's in principle possible for us
-			 * to continue to try, it seems wiser to give up at
-			 * this point to warn and fail explicitly with a
-			 * distinctive error.
-			 */
-			cmn_err(CE_WARN, "zone_create() failed: all available "
-			    "zone IDs have netstacks still in use");
-			return (set_errno(ENFILE));
-		}
-
-		cmn_err(CE_WARN, "unable to reuse zone ID %d; "
-		    "netstack still in use", zoneid);
-	}
-
 	zone = kmem_zalloc(sizeof (zone_t), KM_SLEEP);
-	zone->zone_id = zoneid;
-	zone->zone_did = zone_did;
+	zoneid = zone->zone_id = id_alloc(zoneid_space);
 	zone->zone_status = ZONE_IS_UNINITIALIZED;
 	zone->zone_pool = pool_default;
 	zone->zone_pool_mod = gethrtime();
@@ -5345,7 +5177,6 @@
 static int
 zone_empty(zone_t *zone)
 {
-	int cnt = 0;
 	int waitstatus;
 
 	/*
@@ -5356,16 +5187,7 @@
 	ASSERT(MUTEX_NOT_HELD(&zonehash_lock));
 	while ((waitstatus = zone_status_timedwait_sig(zone,
 	    ddi_get_lbolt() + hz, ZONE_IS_EMPTY)) == -1) {
-		boolean_t force = B_FALSE;
-
-		/* Every 30 seconds, try harder */
-		if (cnt++ >= 30) {
-			cmn_err(CE_WARN, "attempt to force kill zone %d\n",
-			    zone->zone_id);
-			force = B_TRUE;
-			cnt = 0;
-		}
-		killall(zone->zone_id, force);
+		killall(zone->zone_id);
 	}
 	/*
 	 * return EINTR if we were signaled
@@ -6170,14 +5992,6 @@
 		}
 		kmem_free(zbuf, bufsize);
 		break;
-	case ZONE_ATTR_DID:
-		size = sizeof (zoneid_t);
-		if (bufsize > size)
-			bufsize = size;
-
-		if (buf != NULL && copyout(&zone->zone_did, buf, bufsize) != 0)
-			error = EFAULT;
-		break;
 	case ZONE_ATTR_SCHED_FIXEDHI:
 		size = sizeof (boolean_t);
 		if (bufsize > size)
@@ -7010,7 +6824,6 @@
 			zs.doi = zs32.doi;
 			zs.label = (const bslabel_t *)(uintptr_t)zs32.label;
 			zs.flags = zs32.flags;
-			zs.zoneid = zs32.zoneid;
 #else
 			panic("get_udatamodel() returned bogus result\n");
 #endif
@@ -7021,7 +6834,7 @@
 		    (caddr_t)zs.rctlbuf, zs.rctlbufsz,
 		    (caddr_t)zs.zfsbuf, zs.zfsbufsz,
 		    zs.extended_error, zs.match, zs.doi,
-		    zs.label, zs.flags, zs.zoneid));
+		    zs.label, zs.flags));
 	case ZONE_BOOT:
 		return (zone_boot((zoneid_t)(uintptr_t)arg1));
 	case ZONE_DESTROY:
@@ -7300,7 +7113,7 @@
 	 * zone_ki_call_zoneadmd() will do a more thorough job of this
 	 * later.
 	 */
-	killall(zone->zone_id, B_FALSE);
+	killall(zone->zone_id);
 	/*
 	 * Now, create the thread to contact zoneadmd and do the rest of the
 	 * work.  This thread can't be created in our zone otherwise
--- old/usr/src/uts/common/sys/Makefile	Wed Oct  5 00:33:53 2016
+++ new/usr/src/uts/common/sys/Makefile	Wed Oct  5 00:33:53 2016
@@ -23,9 +23,9 @@
 # Copyright (c) 1989, 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright 2014, Joyent, Inc. All rights reserved.
 # Copyright 2013 Garrett D'Amore <garrett@damore.org>
-# Copyright 2015, Joyent, Inc. All rights reserved.
 # Copyright 2013 Saso Kiselkov. All rights reserved.
 # Copyright 2015 Igor Kozhukhov <ikozhukhov@gmail.com>
+# Copyright 2015, Joyent, Inc. All rights reserved.
 # Copyright 2016 Nexenta Systems, Inc.
 #
 
@@ -251,7 +251,6 @@
 	flock.h			\
 	flock_impl.h		\
 	fork.h			\
-	frameio.h		\
 	fss.h			\
 	fsspriocntl.h		\
 	fsid.h			\
@@ -356,7 +355,6 @@
 	lockfs.h		\
 	lockstat.h		\
 	lofi.h			\
-	lofi_impl.h		\
 	log.h			\
 	logindmux.h		\
 	logindmux_impl.h	\
@@ -429,9 +427,6 @@
 	ontrap.h		\
 	open.h			\
 	openpromio.h		\
-	overlay.h		\
-	overlay_common.h	\
-	overlay_target.h	\
 	panic.h			\
 	param.h			\
 	pathconf.h		\
@@ -654,8 +649,6 @@
 	vmem.h			\
 	vmem_impl.h		\
 	vmsystm.h		\
-	vnd.h			\
-	vnd_errno.h		\
 	vnic.h			\
 	vnic_impl.h		\
 	vnode.h			\
@@ -667,7 +660,6 @@
 	vuid_queue.h		\
 	vuid_state.h		\
 	vuid_store.h		\
-	vxlan.h			\
 	wait.h			\
 	waitq.h			\
 	wanboot_impl.h		\
@@ -868,6 +860,7 @@
 	autofs.h		\
 	decomp.h		\
 	dv_node.h		\
+	sdev_impl.h		\
 	fifonode.h		\
 	hsfs_isospec.h		\
 	hsfs_node.h		\
@@ -874,8 +867,6 @@
 	hsfs_rrip.h		\
 	hsfs_spec.h		\
 	hsfs_susp.h		\
-	hyprlofs.h		\
-	hyprlofs_info.h		\
 	lofs_info.h		\
 	lofs_node.h		\
 	mntdata.h		\
@@ -885,8 +876,6 @@
 	pc_label.h		\
 	pc_node.h		\
 	pxfs_ki.h		\
-	sdev_impl.h		\
-	sdev_plugin.h		\
 	snode.h			\
 	swapnode.h		\
 	tmp.h			\
@@ -1011,7 +1000,6 @@
 
 SYSEVENTHDRS=		\
 	ap_driver.h     \
-	datalink.h	\
 	dev.h		\
 	domain.h        \
 	dr.h            \
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/uts/common/sys/fs/tmp.h	Wed Oct  5 00:33:53 2016
+++ new/usr/src/uts/common/sys/fs/tmp.h	Wed Oct  5 00:33:53 2016
@@ -23,7 +23,7 @@
  * All rights reserved.  Use is subject to license terms.
  */
 /*
- * Copyright 2016 Joyent, Inc.
+ * Copyright 2015 Joyent, Inc.
  */
 
 #ifndef	_SYS_FS_TMP_H
@@ -43,10 +43,8 @@
 	struct vfs	*tm_vfsp;	/* filesystem's vfs struct */
 	struct tmpnode	*tm_rootnode;	/* root tmpnode */
 	char 		*tm_mntpath;	/* name of tmpfs mount point */
-	size_t		tm_anonmax;	/* file system max anon reservation */
-	size_t		tm_anonmem;	/* bytes of reserved anon memory */
-					/* and allocated kmem for the fs */
-	size_t		tm_allocmem;	/* bytes alloced from tmp_kmem_ funcs */
+	ulong_t		tm_anonmax;	/* file system max anon reservation */
+	pgcnt_t		tm_anonmem;	/* pages of reserved anon memory */
 	dev_t		tm_dev;		/* unique dev # of mounted `device' */
 	uint_t		tm_gen;		/* pseudo generation number for files */
 	kmutex_t	tm_contents;	/* lock for tmount structure */
@@ -60,7 +58,6 @@
 #define	VTOTM(vp)		((struct tmount *)(vp)->v_vfsp->vfs_data)
 #define	VTOTN(vp)		((struct tmpnode *)(vp)->v_data)
 #define	TNTOV(tp)		((tp)->tn_vnode)
-#define	TNTOTM(tp)		(VTOTM(TNTOV(tp)))
 #define	tmpnode_hold(tp)	VN_HOLD(TNTOV(tp))
 #define	tmpnode_rele(tp)	VN_RELE(TNTOV(tp))
 
@@ -72,31 +69,31 @@
 
 /*
  * tmpfs_minfree is the amount (in pages) of anonymous memory that tmpfs
- * leaves free for the rest of the system.  In antiquity, this number could be
- * relevant on a system-wide basis, as physical DRAM was routinely exhausted;
- * however, in more modern times, the relative growth of DRAM with respect to
- * application footprint means that this number is only likely to become
- * factor in a virtualized OS environment (e.g., a zone) -- and even then only
- * when DRAM and swap have both been capped low to allow for maximum tenancy.
- * TMPMINFREE -- the value from which tmpfs_minfree is derived -- should
- * therefore be configured to a value that is roughly the smallest practical
- * value for memory + swap minus the largest reasonable size for tmpfs in such
- * a configuration.  As of this writing, the smallest practical memory + swap
- * configuration is 128MB, and it seems reasonable to allow tmpfs to consume
- * no more than seven-eighths of this, yielding a TMPMINFREE of 16MB.  Care
- * should be exercised in changing this:  tuning this value too high will
- * result in spurious ENOSPC errors in tmpfs in small zones (a problem that
- * can induce cascading failure surprisingly often); tuning this value too low
- * will result in tmpfs consumption alone to alone induce application-level
- * memory allocation failure.
+ * leaves free for the rest of the system.  E.g. in a system with 32MB of
+ * configured swap space, if 16MB were reserved (leaving 16MB free),
+ * tmpfs could allocate up to 16MB - tmpfs_minfree.  The default value
+ * for tmpfs_minfree is btopr(TMPMINFREE) but it can cautiously patched
+ * to a different number of pages.
+ * NB: If tmpfs allocates too much swap space, other processes will be
+ * unable to execute.
  */
-#define	TMPMINFREE	16 * 1024 * 1024	/* 16 Megabytes */
+#define	TMPMINFREE	2 * 1024 * 1024	/* 2 Megabytes */
 
 extern size_t	tmpfs_minfree;		/* Anonymous memory in pages */
 
+/*
+ * tmpfs can allocate only a certain percentage of kernel memory,
+ * which is used for tmpnodes, directories, file names, etc.
+ * This is statically set as TMPMAXFRACKMEM of physical memory.
+ * The actual number of allocatable bytes can be patched in tmpfs_maxkmem.
+ */
+#define	TMPMAXFRACKMEM	25	/* 1/25 of physical memory */
+
+extern size_t 	tmp_kmemspace;
+extern size_t	tmpfs_maxkmem;	/* Allocatable kernel memory in bytes */
+
 extern	void	tmpnode_init(struct tmount *, struct tmpnode *,
 	struct vattr *, struct cred *);
-extern	void	tmpnode_cleanup(struct tmpnode *tp);
 extern	int	tmpnode_trunc(struct tmount *, struct tmpnode *, ulong_t);
 extern	void	tmpnode_growmap(struct tmpnode *, ulong_t);
 extern	int	tdirlookup(struct tmpnode *, char *, struct tmpnode **,
@@ -103,21 +100,20 @@
     struct cred *);
 extern	int	tdirdelete(struct tmpnode *, struct tmpnode *, char *,
 	enum dr_op, struct cred *);
-extern	int	tdirinit(struct tmpnode *, struct tmpnode *);
+extern	void	tdirinit(struct tmpnode *, struct tmpnode *);
 extern	void	tdirtrunc(struct tmpnode *);
+extern	void	*tmp_memalloc(size_t, int);
+extern	void	tmp_memfree(void *, size_t);
 extern	int	tmp_resv(struct tmount *, struct tmpnode *, size_t, int);
 extern	int	tmp_taccess(void *, int, struct cred *);
 extern	int	tmp_sticky_remove_access(struct tmpnode *, struct tmpnode *,
 	struct cred *);
-extern	int	tmp_convnum(char *, size_t *);
+extern	int	tmp_convnum(char *, pgcnt_t *);
 extern	int	tmp_convmode(char *, mode_t *);
 extern	int	tdirenter(struct tmount *, struct tmpnode *, char *,
 	enum de_op, struct tmpnode *, struct tmpnode *, struct vattr *,
 	struct tmpnode **, struct cred *, caller_context_t *);
 
-extern void	*tmp_kmem_zalloc(struct tmount *, size_t, int);
-extern void	tmp_kmem_free(struct tmount *, void *, size_t);
-
 #define	TMP_MUSTHAVE	0x01
 
 #ifdef	__cplusplus
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/uts/common/sys/proc.h	Wed Oct  5 00:33:54 2016
+++ new/usr/src/uts/common/sys/proc.h	Wed Oct  5 00:33:54 2016
@@ -21,7 +21,7 @@
 
 /*
  * Copyright (c) 1988, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2015 Joyent, Inc.  All rights reserved.
+ * Copyright (c) 2014 Joyent, Inc.  All rights reserved.
  */
 
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
@@ -722,10 +722,6 @@
 extern	void	thread_init(void);
 extern	void	thread_load(kthread_t *, void (*)(), caddr_t, size_t);
 
-extern	void	thread_splitstack(void (*)(void *), void *, size_t);
-extern	void	thread_splitstack_run(caddr_t, void (*)(void *), void *);
-extern	void	thread_splitstack_cleanup(void);
-
 extern	void	tsd_create(uint_t *, void (*)(void *));
 extern	void	tsd_destroy(uint_t *);
 extern	void	*tsd_getcreate(uint_t *, void (*)(void *), void *(*)(void));
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/uts/common/sys/socketvar.h	Wed Oct  5 00:33:55 2016
+++ new/usr/src/uts/common/sys/socketvar.h	Wed Oct  5 00:33:55 2016
@@ -21,7 +21,6 @@
 
 /*
  * Copyright (c) 1996, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright 2015 Joyent, Inc.
  */
 
 /*	Copyright (c) 1983, 1984, 1985, 1986, 1987, 1988, 1989 AT&T	*/
@@ -103,7 +102,6 @@
 
 typedef struct sonodeops sonodeops_t;
 typedef struct sonode sonode_t;
-typedef boolean_t (*so_krecv_f)(sonode_t *, mblk_t *, size_t, int, void *);
 
 struct sodirect_s;
 
@@ -246,10 +244,6 @@
 	struct sof_instance	*so_filter_top;		/* top of stack */
 	struct sof_instance	*so_filter_bottom;	/* bottom of stack */
 	clock_t			so_filter_defertime;	/* time when deferred */
-
-	/* Kernel direct receive callbacks */
-	so_krecv_f		so_krecv_cb;		/* recv callback */
-	void			*so_krecv_arg;		/* recv cb arg */
 };
 
 #define	SO_HAVE_DATA(so)						\
@@ -973,15 +967,6 @@
 extern int	so_copyin(const void *, void *, size_t, int);
 extern int	so_copyout(const void *, void *, size_t, int);
 
-/*
- * Functions to manipulate the use of direct receive callbacks. This should not
- * be used outside of sockfs and ksocket. These are generally considered a use
- * once interface for a socket and will cause all outstanding data on the socket
- * to be flushed.
- */
-extern int	so_krecv_set(sonode_t *, so_krecv_f, void *);
-extern void	so_krecv_unblock(sonode_t *);
-
 #endif
 
 /*
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/uts/common/sys/thread.h	Wed Oct  5 00:33:55 2016
+++ new/usr/src/uts/common/sys/thread.h	Wed Oct  5 00:33:55 2016
@@ -24,10 +24,6 @@
  * Use is subject to license terms.
  */
 
-/*
- * Copyright (c) 2015, Joyent, Inc.  All rights reserved.
- */
-
 #ifndef	_SYS_THREAD_H
 #define	_SYS_THREAD_H
 
@@ -72,8 +68,6 @@
 	void	(*free_op)(void *, int); /* function which frees the context */
 	void	*arg;		/* argument to above functions, ctx pointer */
 	struct ctxop *next;	/* next context ops */
-	hrtime_t save_ts;		/* timestamp of last save */
-	hrtime_t restore_ts;		/* timestamp of last restore */
 } ctxop_t;
 
 /*
@@ -372,7 +366,7 @@
 #define	T_WOULDBLOCK	0x0020	/* for lockfs */
 #define	T_DONTBLOCK	0x0040	/* for lockfs */
 #define	T_DONTPEND	0x0080	/* for lockfs */
-#define	T_SPLITSTK	0x0100	/* kernel stack is currently split */
+#define	T_SYS_PROF	0x0100	/* profiling on for duration of system call */
 #define	T_WAITCVSEM	0x0200	/* waiting for a lwp_cv or lwp_sema on sleepq */
 #define	T_WATCHPT	0x0400	/* thread undergoing a watchpoint emulation */
 #define	T_PANIC		0x0800	/* thread initiated a system panic */
@@ -601,7 +595,6 @@
 caddr_t	thread_stk_init(caddr_t);	/* init thread stack */
 
 extern int default_binding_mode;
-extern int default_stksize;
 
 #endif	/* _KERNEL */
 
No differences encountered
No differences encountered
No differences encountered
No differences encountered
No differences encountered
--- old/usr/src/uts/common/sys/vnode.h	Wed Oct  5 00:33:56 2016
+++ new/usr/src/uts/common/sys/vnode.h	Wed Oct  5 00:33:56 2016
@@ -21,7 +21,7 @@
 
 /*
  * Copyright (c) 1988, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright 2016 Joyent, Inc.
+ * Copyright (c) 2014, Joyent, Inc. All rights reserved.
  */
 
 /*	Copyright (c) 1983, 1984, 1985, 1986, 1987, 1988, 1989 AT&T	*/
@@ -221,59 +221,6 @@
  * In particular, file systems should not access other fields; they may
  * change or even be removed.  The functionality which was once provided
  * by these fields is available through vn_* functions.
- *
- * VNODE PATH THEORY:
- * In each vnode, the v_path field holds a cached version of the canonical
- * filesystem path which that node represents.  Because vnodes lack contextual
- * information about their own name or position in the VFS hierarchy, this path
- * must be calculated when the vnode is instantiated by operations such as
- * fop_create, fop_lookup, or fop_mkdir.  During said operations, both the
- * parent vnode (and its cached v_path) and future name are known, so the
- * v_path of the resulting object can easily be set.
- *
- * The caching nature of v_path is complicated in the face of directory
- * renames.  Filesystem drivers are responsible for calling vn_renamepath when
- * a fop_rename operation succeeds.  While the v_path on the renamed vnode will
- * be updated, existing children of the directory (direct, or at deeper levels)
- * will now possess v_path caches which are stale.
- *
- * It is expensive (and for non-directories, impossible) to recalculate stale
- * v_path entries during operations such as vnodetopath.  The best time during
- * which to correct such wrongs is the same as when v_path is first
- * initialized: during fop_create/fop_lookup/fop_mkdir/etc, where adequate
- * context is available to generate the current path.
- *
- * In order to quickly detect stale v_path entries (without full lookup
- * verification) to trigger a v_path update, the v_path_stamp field has been
- * added to vnode_t.  As part of successful fop_create/fop_lookup/fop_mkdir
- * operations, where the name and parent vnode are available, the following
- * rules are used to determine updates to the child:
- *
- * 1. If the parent lacks a v_path, clear any existing v_path and v_path_stamp
- *    on the child.  Until the parent v_path is refreshed to a valid state, the
- *    child v_path must be considered invalid too.
- *
- * 2. If the child lacks a v_path (implying v_path_stamp == 0), it inherits the
- *    v_path_stamp value from its parent and its v_path is updated.
- *
- * 3. If the child v_path_stamp is less than v_path_stamp in the parent, it is
- *    an indication that the child v_path is stale.  The v_path is updated and
- *    v_path_stamp in the child is set to the current hrtime().
- *
- *    It does _not_ inherit the parent v_path_stamp in order to propagate the
- *    the time of v_path invalidation through the directory structure.  This
- *    prevents concurrent invalidations (operating with a now-incorrect v_path)
- *    at deeper levels in the tree from persisting.
- *
- * 4. If the child v_path_stamp is greater or equal to the parent, no action
- *    needs to be taken.
- *
- * Note that fop_rename operations do not follow this ruleset.  They perform an
- * explicit update of v_path and v_path_stamp (setting it to the current time)
- *
- * With these constraints in place, v_path invalidations and updates should
- * proceed in a timely manner as vnodes are accessed.  While there still are
- * limited cases where vnodetopath operations will fail, the risk is minimized.
  */
 
 struct fem_head;	/* from fem.h */
@@ -300,7 +247,6 @@
 	void		*v_locality;	/* hook for locality info */
 	struct fem_head	*v_femhead;	/* fs monitoring */
 	char		*v_path;	/* cached path */
-	hrtime_t	v_path_stamp;	/* timestamp for cached path */
 	uint_t		v_rdcnt;	/* open for read count  (VREG only) */
 	uint_t		v_wrcnt;	/* open for write count (VREG only) */
 	u_longlong_t	v_mmap_read;	/* mmap read count */
@@ -792,7 +738,7 @@
 	VE_RMDIR	= 4,	/* Remove of directory vnode's name */
 	VE_CREATE	= 5,	/* Create with vnode's name which exists */
 	VE_LINK		= 6, 	/* Link with vnode's name as source */
-	VE_RENAME_DEST_DIR = 7,	/* Rename with vnode as target dir */
+	VE_RENAME_DEST_DIR	= 7, 	/* Rename with vnode as target dir */
 	VE_MOUNTEDOVER	= 8, 	/* File or Filesystem got mounted over vnode */
 	VE_TRUNCATE = 9,	/* Truncate */
 	VE_PRE_RENAME_SRC = 10,	/* Pre-rename, with vnode as source */
@@ -1347,11 +1293,6 @@
     const char *path, size_t plen);
 void vn_renamepath(vnode_t *dvp, vnode_t *vp, const char *nm, size_t len);
 
-/* Private vnode manipulation functions */
-void vn_clearpath(vnode_t *, hrtime_t);
-void vn_updatepath(vnode_t *, vnode_t *, const char *);
-
-
 /* Vnode event notification */
 void	vnevent_rename_src(vnode_t *, vnode_t *, char *, caller_context_t *);
 void	vnevent_rename_dest(vnode_t *, vnode_t *, char *, caller_context_t *);
@@ -1400,9 +1341,6 @@
 
 int	vn_vmpss_usepageio(vnode_t *);
 
-/* Empty v_path placeholder */
-extern char *vn_vpath_empty;
-
 /*
  * Needed for use of IS_VMODSORT() in kernel.
  */
No differences encountered
